config/routes.rb
get 'prologinid/login', :to => 'redmine_oauth#prologin_oauth'
get 'prologinid/complete', :to => 'redmine_oauth#prologin_oauth_callback', :as => 'prologin_oauth_callback'

app/controllers/redmine_oauth_controller.rb
require 'account_controller'
require 'json'

class RedmineOauthController < AccountController

  def prologin_oauth
    if Setting.plugin_prologinid_connect[:oauth_authentication]
      session[:back_url] = params[:back_url]
      redirect_to oauth_client.auth_code.authorize_url(:redirect_uri => prologin_oauth_callback_url, :scope => scopes)
    else
      password_authentication
    end
  end

  def prologin_oauth_callback
    if params[:error]
      flash[:error] = l(:notice_access_denied)
      redirect_to signin_path
    else
      token = oauth_client.auth_code.get_token(params[:code], :redirect_uri => prologin_oauth_callback_url)
      result = token.get(settings[:userinfo_endpoint_url])
      info = JSON.parse(result.body)
      if info && info["email_verified"]
        try_to_login info
      else
        flash[:error] = l(:notice_unable_to_obtain_credentials)
        redirect_to signin_path
      end
    end
  end

  def get_roles info
    roles = info["resource_access"][settings[:client_id]]
    return [] if roles == nil
    return [] if roles["roles"] == nil
    return roles["roles"]
  end

  def user_has_role info, role
    return get_roles(info).include? role
  end

  def apply_groups info, user
    groups_to_add = get_roles(info).select { |r| r.start_with? "redmine::group::" }
    groups_to_add.map! { |r| Integer(r.delete_prefix("redmine::group::")) }
    user.groups.each do | group |
      unless groups_to_add.include? group.id
        puts("removing #{user.to_s} from #{group.to_s}")
        user.groups.delete(group.id)
      else
        groups_to_add.delete group.id
      end
    end

    groups_to_add.each do | gid |
      group = Group.find(gid)
      puts("adding #{user.to_s} to group #{group.to_s}")
      user.groups << group
    end
  end

  def username_or_legacy_login info
    return info["legacy_redmine_username"] if info.has_key? "legacy_redmine_username"
    return info["preferred_username"]
  end

  def update_user info, user
    user.firstname = info["given_name"]
    user.lastname = info["family_name"]
    user.mail = info["email"]
    user.password = nil
    user.admin = user_has_role info, "redmine::superuser"
    return user
  end

  def try_to_login info
   params[:back_url] = session[:back_url]
   session.delete(:back_url)
   unless user_has_role info, "redmine::access"
    flash[:error] = l(:notice_not_authorized_to_access_application)
    redirect_to signin_path
    return
   end
   user = User.where(login: username_or_legacy_login(info)).first_or_create
    if user.new_record?
      user.login = username_or_legacy_login(info)
      user = update_user info, user
      user.register
      user.activate
      user.save!
      apply_groups info, user

      successful_authentication(user)
    elsif user.active?
      user = update_user info, user
      user.save!
      apply_groups info, user
      successful_authentication(user)
    else
      account_pending(user)
    end
  end

  def oauth_client
    @client ||= OAuth2::Client.new(settings[:client_id], settings[:client_secret],
      :authorize_url => settings[:authorize_endpoint_url],
      :token_url => settings[:token_endpoint_url])
  end

  def settings
    @settings ||= Setting.plugin_prologinid_connect
  end

  def scopes
    'profile roles email legacy_identities'
  end

end

app/views/hooks/_view_account_login_bottom.html.erb
<% if Setting.plugin_prologinid_connect[:oauth_authentication] %>
  <div style="text-align: center;">
    <%= link_to prologinid_login_path(:back_url => back_url) do %>
      <%= button_tag :class => 'button-login' do %>
        <%= content_tag :div, "Connexion avec ProloginID", :class => 'button-login-text', :style => 'padding: 6px 12px;' %>
      <% end %>
    <% end %>
  </div>
<% end %>

app/views/settings/_prologinid_connect_settings.erb
<p>
  <label>Client ID:</label>
  <%= text_field_tag 'settings[client_id]', @settings[:client_id] %>
</p>
<p>
  <label>Client Secret:</label>
  <%= text_field_tag 'settings[client_secret]', @settings[:client_secret] %>
</p>
<p>
  <label>Token Endpoint URL</label>
  <%= text_field_tag 'settings[token_endpoint_url]', @settings[:token_endpoint_url] %>
</p> 
<p>
  <label>Authorize Endpoint URL</label>
  <%= text_field_tag 'settings[authorize_endpoint_url]', @settings[:authorize_endpoint_url] %>
</p>
<p>
  <label>Userinfo Endpoint URL</label>
  <%= text_field_tag 'settings[userinfo_endpoint_url]', @settings[:userinfo_endpoint_url] %>
</p>
<p>
  <label>Enable OAuth2 authentication</label>
  <%= check_box_tag "settings[oauth_authentication]", true, @settings[:oauth_authentication] %>
</p>
<p>
  <label>Keep local authentication enabled</label>
  <%= check_box_tag "settings[keep_local_authentication]", true, @settings[:keep_local_authentication] %>
</p>